% Perform demosaicking on the Kodak image set using one single filter 
% package with the intent to generate the actual demosaicked images
% 
% IEEE Trans. Image Processing (submitted)
% This software is for provided for non-commercial and research purposes only
% Copyright Eric Dubois (edubois@site.uottawa.ca), University of Ottawa 2010 
% *****************

% Initialize MATLAB Workspace
clc; clear all; close all;

% Setup frame size when computing MSE/PSNR
frame = 11; 

% Select and load filter
% LSLCD algorithm using $f_{ST}$
load('filters\ST\filter_ST_01.mat');
% % LSLCD algorithm using $f_{TO}$
% load('filters\TO\filter_TO_01.mat');
% % LSLCD algorithm using $f_{ST_RE}$
% load('filters\ST_RE\filter_ST_RE_01.mat');
% % LSLCD algorithm using $f_{TO_RE}$
% load('filters\TO_RE\filter_TO_RE_01.mat');

% Load Gaussian filter
load('filters\GF\GF.mat');

% Prepare the filter package
fpkg = 'fpkg.mat';
save(fpkg,'h1','h2a','h2b','hG1','hG2');
clear h1 h2a h2b hG1 hG2;

% Implementation
image_fname='Kodak\01.tiff';
ORIG = im2double(imread(image_fname));
CFA = create_CFA(ORIG);
ESTM = demos_LSLCD(CFA,fpkg);
imwrite(ESTM, 'Kodak\01_out.tiff');
delete(fpkg);